var __awaiter = (this && this.__awaiter) || function (thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
};
var __generator = (this && this.__generator) || function (thisArg, body) {
    var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g = Object.create((typeof Iterator === "function" ? Iterator : Object).prototype);
    return g.next = verb(0), g["throw"] = verb(1), g["return"] = verb(2), typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
    function verb(n) { return function (v) { return step([n, v]); }; }
    function step(op) {
        if (f) throw new TypeError("Generator is already executing.");
        while (g && (g = 0, op[0] && (_ = 0)), _) try {
            if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
            if (y = 0, t) op = [op[0] & 2, t.value];
            switch (op[0]) {
                case 0: case 1: t = op; break;
                case 4: _.label++; return { value: op[1], done: false };
                case 5: _.label++; y = op[1]; op = [0]; continue;
                case 7: op = _.ops.pop(); _.trys.pop(); continue;
                default:
                    if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                    if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                    if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                    if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                    if (t[2]) _.ops.pop();
                    _.trys.pop(); continue;
            }
            op = body.call(thisArg, _);
        } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
        if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
    }
};
var __spreadArray = (this && this.__spreadArray) || function (to, from, pack) {
    if (pack || arguments.length === 2) for (var i = 0, l = from.length, ar; i < l; i++) {
        if (ar || !(i in from)) {
            if (!ar) ar = Array.prototype.slice.call(from, 0, i);
            ar[i] = from[i];
        }
    }
    return to.concat(ar || Array.prototype.slice.call(from));
};
import axios from 'axios';
import moment from 'moment';
var dateTransformer = function (data) {
    if (data instanceof Date) {
        return moment(data).format('YYYY-MM-DDTHH:mm:ssZ');
    }
    if (Array.isArray(data)) {
        return data.map(dateTransformer);
    }
    if (typeof data === 'object' && data !== null) {
        return Object.fromEntries(Object.entries(data).map(function (_a) {
            var key = _a[0], value = _a[1];
            return [key, dateTransformer(value)];
        }));
    }
    return data;
};
export var createPrivateInstance = function (_a) {
    var baseURL = _a.baseURL, handleAuthError = _a.handleAuthError, timeout = _a.timeout;
    var axiosInstance = axios.create({
        baseURL: baseURL,
        timeout: timeout,
        transformRequest: __spreadArray([dateTransformer], axios.defaults.transformRequest, true),
    });
    axiosInstance.interceptors.response.use(function (res) { return res; }, function (err) { return __awaiter(void 0, void 0, void 0, function () {
        var originalRequest;
        var _a, _b, _c, _d;
        return __generator(this, function (_e) {
            switch (_e.label) {
                case 0:
                    if (err.message === 'Network Error') {
                        return [2 /*return*/, Promise.reject({ title: 'Network Error: Please check your connection.' })];
                    }
                    originalRequest = err.config;
                    if (!(err.response && err.response.status === 401 && !originalRequest._retry)) return [3 /*break*/, 2];
                    originalRequest._retry = true;
                    if (!(typeof handleAuthError === 'function')) return [3 /*break*/, 2];
                    return [4 /*yield*/, handleAuthError(axiosInstance, originalRequest, err)];
                case 1: return [2 /*return*/, _e.sent()];
                case 2:
                    if (((_a = err.response) === null || _a === void 0 ? void 0 : _a.status) === 500) {
                        return [2 /*return*/, Promise.reject((_b = err.response.data) !== null && _b !== void 0 ? _b : { title: 'Internal Server Error' })];
                    }
                    return [2 /*return*/, Promise.reject((_d = (_c = err.response) === null || _c === void 0 ? void 0 : _c.data) !== null && _d !== void 0 ? _d : { title: 'Something went wrong' })];
            }
        });
    }); });
    return axiosInstance;
};
export var createPublicInstance = function (_a) {
    var baseURL = _a.baseURL, timeout = _a.timeout;
    var axiosNoAuthInstance = axios.create({
        baseURL: baseURL,
        timeout: timeout,
    });
    axiosNoAuthInstance.interceptors.response.use(function (response) { return response; }, function (error) {
        return Promise.reject((error.response && error.response.data) || { title: 'Something went wrong' });
    });
    return axiosNoAuthInstance;
};
